<?php
namespace App\Models;
use Illuminate\Database\Eloquent\Model;

class RechargeApi extends Model {

    private $rechargeUrl;

    function __construct() {

        $this->rechargeUrl = env('RECHARGE_URL', true);
        $this->rechargeApiKey = env('RECHARGE_API_KEY',true);
    }

    /**
     * get customer details by shopify customer Id
     */
    function getCustomerDetailsByShopifyCustomerId($customerId) {

        $method = 'GET';
        $path = $this->rechargeUrl . 'customers?shopify_customer_id='.$customerId;
        $response = $this->call($method, $path);
        return json_decode($response);
    }

    /**
     * CURL call
     */
    function call($method, $path, $data = []) {

        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $path);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_ENCODING, '');
        curl_setopt($curl, CURLOPT_MAXREDIRS, 10);
        curl_setopt($curl, CURLOPT_TIMEOUT, 30);
        curl_setopt($curl, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
        curl_setopt($curl, CURLOPT_CUSTOMREQUEST, $method);

        if ($method !== 'GET') {

            curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
        }

        curl_setopt($curl, CURLOPT_HTTPHEADER, array(
            "cache-control: no-cache",
            "x-recharge-access-token: " . env('RECHARGE_API_KEY',true),
            "content-type: application/json",
        ));
     
        $response = curl_exec($curl);
        return $response;

    }
}
